
ISIS - Bug #3879

Point Perspective Projection significantly clips edges of images 

2016-03-31 10:08 AM - Kristin Berry

Status: Closed   

Priority: Normal   

Assignee: Tyler Wilson   

Category: API   

Target version: FY17 Sprint 3   

Impact: This fix should not have any impact upon

ISIS.

Software Version:  

Description

Projecting New Horizons LEISA images to a Point Perspective projection results in more than half of the image being clipped off

around the edges.

This problem may also exist for images from other instruments. 

Related issues:

Related to ISIS - UserTestPlan #4501: Point Perspective Projection significan... Closed

History

#1 - 2016-03-31 10:10 AM - Kristin Berry

I spent some time looking into this, but was never actually solved the problem. I suspect that the problem is somewhere in

PointPerspective::XYRange()

#2 - 2016-03-31 03:50 PM - Kristin Berry

Source changed to external because problem was reported by Will Grundy, but can be reproduced internally. 

#3 - 2016-04-01 04:07 PM - Tammy Becker

- Category set to Applications

- Status changed from New to Acknowledged

#4 - 2016-07-12 07:45 AM - Stuart Sides

- Category changed from Applications to API

- Target version set to 3.4.13 (FY16 R3 2016-08-31 Aug)

#5 - 2016-07-19 05:43 PM - Kristin Berry

- Assignee set to Kristin Berry

#6 - 2016-07-19 10:49 PM - Kristin Berry

- Status changed from Acknowledged to In Progress

#7 - 2016-09-30 11:19 AM - Kristin Berry

- Status changed from In Progress to Acknowledged

- Assignee deleted (Kristin Berry)

This problem only appears with the full LORRI basemaps (-90 -> +90 latitude; 0 -> 360 degree longitude) when running map2map. Projecting

individual, non-moasiced cubes with cam2map works as expected.

Even hard-coding a larger XYRange did not fix this problem, so it is actually (I think) something wrong with the projection itself. 

Please contact me (kberry@usgs.gov) for more information, if you've been assigned this ticket, and I haven't updated this with more information. (i.e.
if you are reading this message. I have a google-doc I made for myself to keep notes, but it needs a bit of cleanup/editing-for-clarity before pasting its

contents here.) 

#8 - 2016-10-03 10:50 AM - Stuart Sides

- Target version deleted (3.4.13 (FY16 R3 2016-08-31 Aug))

#9 - 2016-11-01 10:27 AM - Tammy Becker

- Related to UserTestPlan #4501: Point Perspective Projection significantly clips edges of images added

#10 - 2016-11-10 10:18 AM - Jason Laura

- Target version set to FY17 Backlog

#11 - 2016-11-10 11:50 AM - Jason Laura

- Story points set to 4

#12 - 2016-11-10 11:50 AM - Jason Laura

- Target version changed from FY17 Backlog to FY17 Sprint 3

#13 - 2016-11-14 02:00 PM - Tyler Wilson

- Assignee set to Tyler Wilson

#14 - 2016-11-14 02:04 PM - Tyler Wilson

- Status changed from Acknowledged to In Progress

#15 - 2016-11-14 04:21 PM - Stuart Sides

- Status changed from In Progress to Assigned

#16 - 2016-11-14 04:21 PM - Stuart Sides

- Status changed from Assigned to Acknowledged

#17 - 2016-11-14 04:22 PM - Tyler Wilson

- Status changed from Acknowledged to In Progress

#18 - 2016-11-17 01:02 PM - Tyler Wilson

- Impact updated

Kristin was correct.  The XYRange() function in PointPerspective.cpp was incorrect, and needed to be modified.  To the reviewer:  please do a svn diff

|less in this directory:

$ISISROOT/src/base/objs/PointPerspective to view my changes.

The user test plan is one directory above $ISISROOT in the userTestPlan directory.

The script you want to run is:  cam2map_ptpersp_m03879_testplan_1.csh  The file:

cam2map_ptpersp_m03879_testplan_1.txt describes the desired output for this fix to pass the test.

#19 - 2016-11-17 01:03 PM - Tyler Wilson

- Status changed from In Progress to Resolved

2017-01-01 2/4



#20 - 2016-11-18 12:47 PM - Ian Humphrey

- Status changed from Resolved to In Review

#21 - 2016-11-18 01:23 PM - Ian Humphrey

- Status changed from In Review to Feedback

I ran through the test plan and I got results that were not the expected results, I think I might have to ask about this in person.

Also, the changes should be made in the IPCE branch and not trunk.

Review suggestions:

* Make sure to add history comments to TProjection.h and PointPerspective.h

* I might consider adding a comment to the changed line in PointPerspective.cpp (182)

if (abs(g) < (1.0 / m_P))

* I would remove the cout's in TProjection.cpp and PointPerspective.cpp that were added for debugging.

#22 - 2016-11-21 12:36 PM - Ian Humphrey

Disregard previous review.

Suggestions:

Orthographic.cpp:

Remove the cout's in Orthographic::XYRange(minX, maxX, minY, maxY)

PointPerspective.h

Consider updating the history date to the date that you commit the changes

PointPerspective.cpp

In the constructor, there is a lot of whitespace that should probably be removed that occurs before the catch clause near the end of the

constructor.

(Optional) Consider putting an internal history comment on th changes you made to PointPerspective::SetGround(const double lat, const double

lon).

In SetGround(const double lat, const double lon), there is an if statement that was added: if (sqrt(x*x+y*y)> projectionRadius). I would consider

putting whitespace between the arithmetic operators and putting whitespace before the > operator.

In SetGround(const double lat, const double lon), in the if statement mentioned above, there is an assignment: m_good =false. I would put

whitespace after the assignment operator.

I would consider putting an internal history comment on the XYRange method saying what was changed.

PointPerspective unitTest.cpp

There is a lot of whitespace at the end of the unitTest before the catch clause that should probably be removed.

There may need to be os specific truth data for the new systems depending on the results of the test.

The old os specific truth data may also need to be removed.

2017-01-01 3/4



#23 - 2016-11-21 12:42 PM - Ian Humphrey

Re-ran the user test plan, looks good to me!

#24 - 2016-11-22 01:14 AM - Tyler Wilson

- Status changed from Feedback to Resolved

#25 - 2016-11-22 10:53 AM - Ian Humphrey

- Status changed from Resolved to In Review

#26 - 2016-11-22 10:54 AM - Ian Humphrey

- Status changed from In Review to Closed

Make sure to get rid of cout's in Orthographic.cpp.
